#include <stdio.h>
#include <stdlib.h>
#include "../tokenizer.h"

#define TESTOK(a) if ((a)) { printf("%s:%d - test fail\n", __FILE__, __LINE__); return 1; }
#define TESTNOK(a) if (!(a)) { printf("%s:%d - test fail\n", __FILE__, __LINE__); return 1; }

int test1()
{
	Tokenizer t;
	char teststring[] = "AA BB, CC DD,,";
	                  // 0123456789012345
	                  // ^  ^  ^^  ^  ^^^
	t.init(teststring, ", ");
	TESTOK(t.count() != 7);
	TESTOK(t.equals(0, "AA "));
	TESTOK(t.equals(0, " AA"));
	TESTOK(t.equals(0, "aA"));
	TESTNOK(t.equalsNocase(0, "aA"));
	TESTNOK(t.equalsNocase(0, "aa"));
	TESTNOK(t.equalsNocase(0, "Aa"));
	TESTNOK(t.equalsNocase(0, "AA"));
	TESTOK(t.equalsNocase(0, "AA "));
	
	TESTNOK(t.equals(0, "AA"));
	TESTNOK(t.equals(1, "BB"));
	TESTNOK(t.equals(2, ""));
	TESTNOK(t.equals(3, "CC"));
	TESTNOK(t.equals(4, "DD"));
	TESTNOK(t.equals(5, ""));
	TESTNOK(t.equals(6, ""));

	TESTOK(t.equals(0, "AA "));
	TESTOK(t.equals(1, "BB "));
	TESTOK(t.equals(2, " "));
	TESTOK(t.equals(3, "CC "));
	TESTOK(t.equals(4, "DD "));
	TESTOK(t.equals(5, " "));
	TESTOK(t.equals(6, " "));

	return 0;
}

int test2()
{
	Tokenizer t;
	char teststring[] = "test";
	t.init(teststring, ", ");

	TESTOK(t.count() != 1);
	TESTNOK(t.equals(0, "test"));

	return 0;
}

void main(void)
{
	if (test1()) printf("test1 failed\n");
	if (test2()) printf("test2 failed\n");	
}